# {{ ansible_managed }}

###############
# Loopback
###############

auto lo
iface lo inet loopback
{% if lo is defined %}
    address {{ lo }}/32
{%   if 'borderleafs' in group_names or 'leafs' in group_names %}
    vxlan-local-tunnelip {{ lo }}
{%     if mlag is defined %}
    clagd-vxlan-anycast-ip {{ mlag.anycast }}
{%     endif %}
{%   endif %}
{% endif %}

###############
# Mgmt interface
###############

allow-mgmt eth0
iface eth0 inet dhcp
    vrf mgmt

allow-mgmt mgmt
iface mgmt
    address 127.0.0.1/8
    address ::1/128
    vrf-table auto

{% if underlay is defined and 'bgp' in underlay %}
###############
# Fabric Links
###############

{%   for port in underlay.bgp.members %}
auto {{ port }}
iface {{ port }}
    mtu 9216

{%   endfor %}
{% endif %}
{% set edgevids = [] %}
{% set edgeports = [] %}
{% if edge is defined and 'vrfs' in edge %}
###############
# Edge Links
###############

{%   for vrf in edge.vrfs %}
auto {{ vrf.name }}
iface {{ vrf.name }}
    vrf-table auto

{%     if 'vlans' in vrf %}
{%       for vlan in vrf.vlans %}
{%         do edgevids.append(vlan.vid) %}
auto vlan{{ vlan.vid }}
iface vlan{{ vlan.vid }}
    vlan-raw-device bridge
    vlan-id {{ vlan.vid }}
    address {{ vlan.subnet }}
{%           if 'svi' in vlan %}
    address-virtual {{ vlan.svi.mac }} {{ vlan.svi.ip }}
{%           endif %}
    vrf {{ vrf.name }}

{%       endfor %}
{%     endif %}
{%     if 'bonds' in vrf %}
{%       for bond in vrf.bonds %}
{%         if 'subnet' not in bond %}
{%           do edgeports.append(bond.name) %}
{%         endif %}
auto {{ bond.name }}
iface {{ bond.name }}
    mtu {{ bond.mtu }}
    clag-id {{ bond.clag_id }}
{%         if bond.members is not string %}
    bond-slaves {{ bond.members | join(' ') }}
{%         else %}
    bond-slaves {{ member.ports }}
{%         endif %}
{%         if bond.lacp_bypass is sameas true %}
    bond-lacp-bypass-allow yes
{%         endif %}
{%         if bond.balance_xor is sameas true %}
    bond-mode balance-xor
{%         endif %}
    mstpctl-bpduguard yes
    mstpctl-portadminedge yes
{%         if bond.untagged is defined and bond.tagged is undefined %}
    bridge-access {{ bond.untagged }}
{%         elif bond.tagged is defined and bond.tagged|length >= 1 %}
    bridge-pvid {{ bond.untagged | default('2') }}
    bridge-vids {{ bond.tagged | join(' ') }}
{%         elif bond.subnet is defined %}
    vrf {{ vrf.name }}
    address {{ bond.subnet }}
{%         endif %}

{%       endfor %}
{%     endif %}
{%     if 'ports' in vrf %}
{%       for port in vrf.ports %}
{%         if 'subnet' not in port %}
{%           do edgeports.append(port.name) %}
{%         endif %}
auto {{ port.name }}
iface {{ port.name }}
    mtu {{ port.mtu }}
{%         if port.untagged is defined and port.tagged is undefined %}
    bridge-access {{ port.untagged }}
{%         elif port.tagged is defined and port.tagged|length >= 1 %}
    bridge-pvid {{ port.untagged | default('2') }}
    bridge-vids {{ port.tagged | join(' ') }}
{%         elif port.subnet is defined %}
    vrf {{ vrf.name }}
    address {{ port.subnet }}
{%         endif %}

{%       endfor %}
{%     endif %}
{%     if 'span_ports' in vrf %}
{%       for port in vrf.span_ports %}
auto {{ port.name }}
iface {{ port.name }}
    mtu {{ port.mtu }}

{%       endfor %}
{%     endif %}
{%     if 'peerlink' in vrf %}
auto peerlink.{{ vrf.peerlink.id }}
iface peerlink.{{ vrf.peerlink.id }}
{%       if 'mtu' in vrf.peerlink %}
    mtu {{ vrf.peerlink.mtu }}
{%       endif %}
    vrf {{ vrf.name }}

{%     endif %}
{%   endfor %}
{% endif %}
{% if mlag is defined %}
###############
# Peer Links
###############

auto peerlink
iface peerlink
    bond-slaves {{ mlag.members | join(' ') }}
    mtu 9216

auto peerlink.4094
iface peerlink.4094
    clagd-backup-ip {{ mlag.backup_ip }}{{ ' vrf mgmt' if 'managementswitches' in group_names else '' }}
    clagd-peer-ip linklocal
{%   if mlag.priority is defined %}
    clagd-priority {{ mlag.priority }}
{%   endif %}
    clagd-sys-mac {{ mlag.sys_mac }}

{% endif %}
{% set vnis = [] %}
{% set l2vids = [] %}
{% if ('borderleafs' in group_names or 'leafs' in group_names) and tenants is defined %}
###############
# Tenants
###############

{%   for tenant in tenants %}
# Tenant: {{ tenant.name }}
{%     for vrf in tenant.vrfs %}
# TENANT VRF
auto vrf{{ vrf.id }}
iface vrf{{ vrf.id }}
    vrf-table auto

{%       for vlan in vrf.vlans %}
{%         set subnet = vlan.subnet | ipv4('network/prefix') %}
{%         do l2vids.append(vlan.vid) %}
# L2 tenant SVI - Anycast GW
auto vlan{{ vlan.vid }}
iface vlan{{ vlan.vid }}
{%         if primary_peer | default(false) %}
    address {{ subnet | ipaddr('2') }}
{%         else %}
    address {{ subnet | ipaddr('3') }}
{%         endif %}
    vlan-id {{ vlan.vid }}
    vlan-raw-device bridge
    address-virtual 00:00:5e:00:01:{{ '%0.2x' % vrf.id }} {{ subnet | ipaddr('1') }}
    vrf vrf{{ vrf.id }}

{%         set vni = 'vni' + vlan.vid | string %}
{%         do vnis.append(vni) %}
# L2 VNI
auto {{ vni }}
iface {{ vni }}
    mtu 9000
    vxlan-id 10{{ vlan.vid }}
    bridge-access {{ vlan.vid }}
    bridge-learning off
    mstpctl-bpduguard yes
    mstpctl-portbpdufilter yes
    bridge-arp-nd-suppress on

{%       endfor %}
# L3 VLAN interface for L3 VNI
auto vlan{{ vrf.l3_vni }}
iface vlan{{ vrf.l3_vni }}
    hwaddress {{ mlag.sys_mac }}
    vlan-id {{ vrf.l3_vni }}
    vlan-raw-device bridge
    vrf vrf{{ vrf.id }}

{%       set vni = 'vni' + vrf.l3_vni | string %}
{%       do vnis.append(vni) %}
# L3 VNI
auto {{ vni }}
iface {{ vni }}
    vxlan-id {{ vrf.l3_vni }}
    bridge-access {{ vrf.l3_vni }}
    bridge-learning off
    mstpctl-bpduguard yes
    mstpctl-portbpdufilter yes
    bridge-arp-nd-suppress on

{%     endfor %}
{%   endfor %}
{% endif %}
{% if 'managementswitches' in group_names and tenants is defined %}
{%   for tenant in tenants %}
{%     for vrf in tenant.vrfs %}
{%       for vlan in vrf.vlans %}
{%         do l2vids.append(vlan.vid) %}
{%       endfor %}
{%     endfor %}
{%   endfor %}
{% endif %}
{% set bonds = [] %}
{% if ('leafs' in group_names or 'managementswitches' in group_names) and servers is defined %}
###############
# Servers
###############

{%   for server in servers %}
# Server: {{ server.name }}
{%     for bond in server.bonds %}
{%       set switches = bond.members | map(attribute='switch') | list %}
{%       if inventory_hostname in switches %}
{%         do switches.remove(inventory_hostname) %}
{%         set port_config = port_configs[bond.port_config] %}
{%         set bond_name = server.short_name[:7] + '-' + port_config.short_name[:6] %}
{%         do bonds.append(bond_name) %}
{%         if switches|length %}
{%           set clag_input = bond.members[0].switch + bond.members[0].ports | string
               + bond.members[1].switch + bond.members[1].ports | string %}
{%           set clag_id = (clag_input | md5)[-4:] | int(0, 16) %}
{%           if clag_id == 0 %}
{%             set clag_id = 65535 %}
{%           endif %}
{%         endif %}
{%         for member in bond.members if inventory_hostname == member.switch %}
auto {{ bond_name }}
iface {{ bond_name }}
    mtu {{ port_config.mtu | default('9000') }}
{%           if clag_id is defined %}
    clag-id {{ clag_id }}
{%           endif %}
{%           if member.ports is not string %}
    bond-slaves {{ member.ports | join(' ') }}
{%           else %}
    bond-slaves {{ member.ports }}
{%           endif %}
{%           if port_config.lacp_bypass is sameas true %}
    bond-lacp-bypass-allow yes
{%           endif %}
{%           if port_config.balance_xor is sameas true %}
    bond-mode balance-xor
{%           endif %}
    mstpctl-bpduguard yes
    mstpctl-portadminedge yes
{%           if port_config.untagged is defined and port_config.tagged is undefined %}
    bridge-access {{ port_config.untagged }}
{%           elif port_config.tagged is defined and port_config.tagged|length >= 1 %}
    bridge-pvid {{ port_config.untagged | default('2') }}
    bridge-vids {{ port_config.tagged | join(' ') }}
{%           endif %}
{%         endfor %}

{%       endif %}
{%     endfor %}
{%   endfor %}
{% endif %}
{% if 'managementswitches' in group_names or 'borderleafs' in group_names %}
###################
# Aggregation Links
###################

{%   if 'managementswitches' in group_names %}
auto swp51
iface swp51

auto swp52
iface swp52

auto uplink
iface uplink
    mtu 1500
    clag-id 1
    bond-slaves swp51 swp52

{%   elif 'borderleafs' in group_names and aggregation_ports is defined %}
{%     for port in aggregation_ports %}
{%       do vnis.append(port.name) %}
{%       for member in port.members if port.mlag is defined %}
auto {{ member }}
iface {{ member }}

{%       endfor %}
auto {{ port.name }}
iface {{ port.name }}
{%       if port.mtu is defined %}
    mtu {{ port.mtu }}
{%       else %}
    mtu 1500
{%       endif %}
{%       if port.alias is defined %}
    alias {{ port.alias }}
{%       endif %}
{%       if port.mlag is defined %}
    clag-id {{ port.clag_id }}
    bond-slaves {{ port.members | join(' ') }}
{%       endif %}
{%       if port.trunk %}
    bridge-vids {{ l2vids | sort | join(' ') }}
{%         if port.vlan is defined %}
    bridge-pvid {{ port.vlan }}
{%         endif %}
{%       else %}
    bridge-access {{ port.vlan }}
{%       endif %}

{%     endfor %}
{%   endif %}
{% endif %}
{% if 'spines' not in group_names %}
###############
# Bridge / Vlans
###############

auto bridge
iface bridge
    bridge-vlan-aware yes
{%   if 'managementswitches' in group_names %}
    bridge-ports {% if mlag is defined %}peerlink {% endif %}{{ bonds | join(' ') if bonds|length else '' }} uplink
    bridge-vids {{ l2vids | join(' ') }}
{%   else %}
    bridge-ports {% if mlag is defined %}peerlink {% endif %}{{ vnis | join (' ') }} {{ bonds | join(' ') if bonds|length else '' }}{{ edgeports | join(' ') if edgeports|length else '' }}
    bridge-vids {{ l2vids | join(' ') }} {{ edgevids | join(' ') }}
    mstpctl-treeprio 8192
{%   endif %}
    bridge-stp on
{% endif %}
